//LF2.cl by v2mixer.livev2.com
int rle(__global char* out, int i, int size) {
	int count = 0;
	for (int j=i + size, k; i<j;) {
		k = i + 1;
		if (out[i] == out[k]) {
			count ++;
		}
		i = k;
	}
	return count;
}

__kernel void LF_1(const int type, const int w, const int h,
	__global const char* in, const int size_i, __global char* out, const int size_o,
	__global int* count
) {
	int gid = get_global_id(0);
	if (gid >= h) return;

	int size_wo = w * size_o;
	int size_wi = w * size_i;
	int o_index = gid * size_wo + gid;

	int j = o_index;
	int k = gid * size_wi;
	out[j] = type;
	out[++j] = in[++k];
	out[++j] = in[++k];
	out[++j] = in[++k];

	k++;
	for (int x=(gid + 1) * size_wi, p=k - size_i; k<x; k++, p++) {
		out[++j] = in[++k] - in[++p];
		out[++j] = in[++k] - in[++p];
		out[++j] = in[++k] - in[++p];
	}

	count[gid] = rle(out, o_index, size_wo);
}

__kernel void LF_2(const int type, const int w, const int h,
	__global const char* in, const int size_i, __global char* out, const int size_o,
	__global int* count
) {
	int gid = get_global_id(0);
	if (gid >= h) return;

	if (gid == 0) {
		LF_1(1, w, h, in, size_i, out, size_o, count);
		return;
	}

	int size_wo = w * size_o;
	int size_wi = w * size_i;
	int o_index = gid * size_wo + gid;

	int j = o_index;
	out[j] = type;
	for (int k=gid * size_wi, x=k + size_wi, p=k - size_wi; k<x; k++, p++) {
		out[++j] = in[++k] - in[++p];
		out[++j] = in[++k] - in[++p];
		out[++j] = in[++k] - in[++p];
	}

	count[gid] = rle(out, o_index, size_wo);
}
